require "fimmed_up/version"
require "fimmed_up/configuration"
require "fimmed_up/client"
require "fimmed_up/parameters"
require "fimmed_up/helpers"

module FimmedUp
  extend Configuration
  include FimmedUp::Helpers   

  def new(options={})
    Client.new(options)
  end

  # Delegate to FimmedUp::Client

  def method_missing(method, *args, &block)
    return super unless new.respond_to?(method)
    new.send(method, *args, &block)
  end

  def respond_to?(method, include_private = false)
    new.respond_to?(method, include_private) || super(method, include_private)
  end

end
