module FimmedUp
  module Configuration
    VALID_CONNECTION_KEYS = [:endpoint, :method].freeze
    VALID_OPTIONS_KEYS    = [:username, :password, :resource].freeze
    VALID_CONFIG_KEYS     = VALID_CONNECTION_KEYS + VALID_OPTIONS_KEYS


    DEFAULT_METHOD      = :get    
    DEFAULT_ENDPOINT    =  'http://10.0.0.136:9292'
    DEFAULT_USERNAME    = ENV["API_USERNAME"].to_s
    DEFAULT_PASSWORD    = ENV["API_PASSWORD"].to_s
    DEFAULT_RESOURCE    = "profile"


    attr_accessor *VALID_CONFIG_KEYS

    # Make sure we have the default values set when we get 'extended'
    def self.extended(base)
      base.reset
    end
        
    def reset
      self.endpoint   = DEFAULT_ENDPOINT
      self.method     = DEFAULT_METHOD      
      self.username   = DEFAULT_USERNAME
      self.password   = DEFAULT_PASSWORD
      self.resource   = DEFAULT_RESOURCE
    end

    def configure
      yield self
    end

    def options
      Hash[ * VALID_CONFIG_KEYS.map { |key| [key, send(key)] }.flatten ]
    end
  end
end