require 'fimmed_up/request'
require 'fimmed_up/helpers'

module FimmedUp
  module Parameters
    include Enumerable
    include FimmedUp::Request
    include FimmedUp::Helpers

    def parameters
      @parameters ||= {}
    end

    def where(args)
      parameters.merge!(args)
      self
    end

    def like(args)      
      parameters.merge!(like_format(args))      
      self
    end
    
    def limit(limit)
      parameters[:limit] = limit
      self
    end

    def find(id)
      parameters.merge!(id: id)
      self   
    end  

    def each(&block)      
      records = self.get(resource, parameters, {})      
      if records.empty? || records == ""
        [{ "error" => "Not Found" }].each(&block)
      else
        json(records).each(&block)
      end
    end

    private
      def like_format(args)       
        return_args = args.map { | key, value | hash = { "#{key.to_s}.like" => "%#{value}%" } }                
        return_args[0]
      end
  end
end