require 'net/http'
require 'uri' 

module FimmedUp
  # Handless HTTP requests
  module Request
    def get(path, params={}, options={})
      request(:get, path, params, options)
    end

    def post(path, params={}, options={})
      request(:post, path, params, options)
    end

    def delete(path, params={}, options={})
      request(:delete, path, params, options)
    end

    def patch(path, params={}, options={})
      request(:patch, path, params, options)
    end

    private

    def request(method, path, params, options)
      response = connection(options).run_request(method, nil, nil, nil) do |request|
        request.options[:raw] = true if options[:raw]        
        case method.to_sym
        when :get
          request.url(path, params)
        when :post          
          request.url(path, params)          
          request.body = params unless params.empty?          
        when :patch
          request.url(path, params)
        when :delete
          request.url(path, params)
        end
      end      
      options[:raw] ? response : response.body
    end

  end # Request

end