require 'faraday'
require 'fimmed_up/error'

module FimmedUp
  module Response
    class RaiseServerError < Faraday::Response::Middleware

      def on_complete(env)
        status  = env[:status].to_i
        body    = env[:body]
        headers = env[:response_headers]

        case status
        when 503
          raise FimmedUp::Error::ServiceUnavailable.new "503 No server is available to handle this request.", headers
        end
      end

    end # RaiseServerError

  end # Response

end